/*
	File: Selectorama.h

	Copyright 1996 by Adobe Systems, Inc.  All rights reserved.

	Header and utilities for Selectorama example selection module.
*/

#ifndef __Selectorama_H__
#define __Selectorama_H__

#if __MWERKS__
#pragma once
#endif

#include "PISelection.h"
#include "PIUtilities.h"

/*****************************************************************************/
/* Scripting keys */
#define selectMin			'seL0'
#define selectMax			'seL1'
#define selectRandom		'shL2'
#define useTarget			'useT'
#define useMerged			'useM'
#define typeSelect			'tseL'
#define typeComposite		'tcoM'
#define keyCreate			'kcrE'
#define typeCreate			'tcrE'
#define typePISel			'tpiS'
#define	createSelection		'crE0'
#define createMaskpath		'crE1'
#define createLayer			'crE2'

/*****************************************************************************/
/* Any constants here */

#define kBlockRows			64
#define kBlockCols			64

#define kFirstItem			4
#define kLastItem			kFirstItem+2

#define kPercentStatic		7
#define kPercentEdit		kPercentStatic+1
#define kPercentSymbol		kPercentEdit+1

#define kPercentMin			0
#define kPercentMax			100

#define kUseRadio1			11
#define kUseRadioLast		kUseRadio1 + 1

#define kCreateRadio1		14
#define kCreateRadioLast	kCreateRadio1+2

#define kInitRandom			1
#define kRandomOn			255
#define kRandomOff			0

#define errCantCreatePath	16989

/*****************************************************************************/

enum
{
	iSelectMin,
	iSelectMax,
	iSelectRandom
};

enum
{
	iUseTarget,
	iUseMerged
};

enum
{
	iCreateSelection,
	iCreateMaskpath,
	iCreateLayer
};

/*****************************************************************************/

extern Handle hDllInstance;

typedef struct Globals
	{
	short 	result;
	short	whatArea;
	short	whatChannels;
	short	percent;
	short	create;
	Boolean	queryForParameters;
	PISelectionParams *selectionParamBlock;
	} Globals, *GPtr, **GHdl;
	
#define gResult 			(globals->result)
#define gStuff  			(globals->selectionParamBlock)
#define gWhatArea 			(globals->whatArea)
#define gWhatChannels		(globals->whatChannels)
#define	gPercent			(globals->percent)
#define gQueryForParameters	(globals->queryForParameters)
#define DoTarget			(gWhatChannels == iUseTarget)
#define gCreate				(globals->create)

/*****************************************************************************/

void DoAbout (GPtr globals);
Boolean DoParameters (GPtr globals);
short KeyToEnum (OSType key, OSType whatType);
OSType EnumToKey (short keyEnum, OSType whatType);
Boolean ReadScriptParams (GPtr globals);
OSErr WriteScriptParams (GPtr globals);

/*****************************************************************************/

#endif /* __Selectorama_H__ */